/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.popupMenus;

import org.eclipse.jface.viewers.ViewerSorter;

/**
 * This class sorts ReferenceEntries.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class ReferenceSorter extends ViewerSorter {

	/* (non-Javadoc) */
	public int category(Object element) {
		if (element instanceof ReferenceEntry) {
			return 0;
		} else {
			return 1;
		}
	}
}
