/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml13.foundation.core.Attribute;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Attribute Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.AttributeLinkImpl#getAttribute
 * <em>Attribute</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.AttributeLinkImpl#getValue
 * <em>Value</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.AttributeLinkImpl#getInstance
 * <em>Instance</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.AttributeLinkImpl#getLinkEnd
 * <em>Link End</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class AttributeLinkImpl extends ModelElementImpl implements AttributeLink {
	/**
	 * The cached value of the '{@link #getAttribute() <em>Attribute</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAttribute()
	 * @generated
	 * @ordered
	 */
	protected Attribute attribute = null;

	/**
	 * The cached value of the '{@link #getValue() <em>Value</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
	protected Instance value = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AttributeLinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getAttributeLink();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Attribute getAttribute() {
		if (attribute != null && attribute.eIsProxy()) {
			Attribute oldAttribute = attribute;
			attribute = (Attribute) eResolveProxy((InternalEObject) attribute);
			if (attribute != oldAttribute) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE, oldAttribute, attribute));
			}
		}
		return attribute;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Attribute basicGetAttribute() {
		return attribute;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAttribute(Attribute newAttribute, NotificationChain msgs) {
		Attribute oldAttribute = attribute;
		attribute = newAttribute;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE, oldAttribute, newAttribute);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAttribute(Attribute newAttribute) {
		if (newAttribute != attribute) {
			NotificationChain msgs = null;
			if (attribute != null)
				msgs = ((InternalEObject) attribute).eInverseRemove(this, CorePackage.ATTRIBUTE__ATTRIBUTE_LINK, Attribute.class, msgs);
			if (newAttribute != null)
				msgs = ((InternalEObject) newAttribute).eInverseAdd(this, CorePackage.ATTRIBUTE__ATTRIBUTE_LINK, Attribute.class, msgs);
			msgs = basicSetAttribute(newAttribute, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE, newAttribute, newAttribute));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getValue() {
		if (value != null && value.eIsProxy()) {
			Instance oldValue = value;
			value = (Instance) eResolveProxy((InternalEObject) value);
			if (value != oldValue) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.ATTRIBUTE_LINK__VALUE, oldValue, value));
			}
		}
		return value;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance basicGetValue() {
		return value;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetValue(Instance newValue, NotificationChain msgs) {
		Instance oldValue = value;
		value = newValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__VALUE, oldValue, newValue);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setValue(Instance newValue) {
		if (newValue != value) {
			NotificationChain msgs = null;
			if (value != null)
				msgs = ((InternalEObject) value).eInverseRemove(this, Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK, Instance.class, msgs);
			if (newValue != null)
				msgs = ((InternalEObject) newValue).eInverseAdd(this, Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK, Instance.class, msgs);
			msgs = basicSetValue(newValue, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__VALUE, newValue, newValue));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getInstance() {
		if (eContainerFeatureID != Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE)
			return null;
		return (Instance) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInstance(Instance newInstance) {
		if (newInstance != eContainer || (eContainerFeatureID != Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE && newInstance != null)) {
			if (EcoreUtil.isAncestor(this, newInstance))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInstance != null)
				msgs = ((InternalEObject) newInstance).eInverseAdd(this, Common_behaviorPackage.INSTANCE__SLOT, Instance.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newInstance, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE, newInstance, newInstance));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public LinkEnd getLinkEnd() {
		if (eContainerFeatureID != Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END)
			return null;
		return (LinkEnd) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setLinkEnd(LinkEnd newLinkEnd) {
		if (newLinkEnd != eContainer || (eContainerFeatureID != Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END && newLinkEnd != null)) {
			if (EcoreUtil.isAncestor(this, newLinkEnd))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newLinkEnd != null)
				msgs = ((InternalEObject) newLinkEnd).eInverseAdd(this, Common_behaviorPackage.LINK_END__QUALIFIED_VALUE, LinkEnd.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newLinkEnd, Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END, newLinkEnd, newLinkEnd));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
				if (attribute != null)
					msgs = ((InternalEObject) attribute).eInverseRemove(this, CorePackage.ATTRIBUTE__ATTRIBUTE_LINK, Attribute.class, msgs);
				return basicSetAttribute((Attribute) otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
				if (value != null)
					msgs = ((InternalEObject) value).eInverseRemove(this, Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK, Instance.class, msgs);
				return basicSetValue((Instance) otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
				return basicSetBinding(null, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
				return basicSetAttribute(null, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
				return basicSetValue(null, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
				return eBasicSetContainer(null, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
				return eBasicSetContainer(null, Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.INSTANCE__SLOT, Instance.class, msgs);
			case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.LINK_END__QUALIFIED_VALUE, LinkEnd.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAME:
			return getName();
		case Common_behaviorPackage.ATTRIBUTE_LINK__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.ATTRIBUTE_LINK__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
			return getComment();
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
			return getPartition();
		case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
			if (resolve)
				return getAttribute();
			return basicGetAttribute();
		case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
			if (resolve)
				return getValue();
			return basicGetValue();
		case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
			return getInstance();
		case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
			return getLinkEnd();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
			setBinding((Binding) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
			setAttribute((Attribute) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
			setValue((Instance) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
			setInstance((Instance) newValue);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
			setLinkEnd((LinkEnd) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
			setBinding((Binding) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
			setAttribute((Attribute) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
			setValue((Instance) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
			setInstance((Instance) null);
			return;
		case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
			setLinkEnd((LinkEnd) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.ATTRIBUTE_LINK__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Common_behaviorPackage.ATTRIBUTE_LINK__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.ATTRIBUTE_LINK__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__BINDING:
			return binding != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__STEREOTYPE:
			return stereotype != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.ATTRIBUTE_LINK__ATTRIBUTE:
			return attribute != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__VALUE:
			return value != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE:
			return getInstance() != null;
		case Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END:
			return getLinkEnd() != null;
		}
		return eDynamicIsSet(eFeature);
	}

} // AttributeLinkImpl
