/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.AssociationRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Interaction;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Message</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getInteraction
 * <em>Interaction</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getMessage
 * <em>Message</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getActivator
 * <em>Activator</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getSender
 * <em>Sender</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getPredecessor
 * <em>Predecessor</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getSuccessor
 * <em>Successor</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getCommunicationConnection
 * <em>Communication Connection</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getAction
 * <em>Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.MessageImpl#getConformingStimulus
 * <em>Conforming Stimulus</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class MessageImpl extends ModelElementImpl implements Message {
	/**
	 * The cached value of the '{@link #getMessage() <em>Message</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage()
	 * @generated
	 * @ordered
	 */
	protected EList message = null;

	/**
	 * The cached value of the '{@link #getActivator() <em>Activator</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getActivator()
	 * @generated
	 * @ordered
	 */
	protected Message activator = null;

	/**
	 * The cached value of the '{@link #getSender() <em>Sender</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSender()
	 * @generated
	 * @ordered
	 */
	protected ClassifierRole sender = null;

	/**
	 * The cached value of the '{@link #getPredecessor() <em>Predecessor</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPredecessor()
	 * @generated
	 * @ordered
	 */
	protected EList predecessor = null;

	/**
	 * The cached value of the '{@link #getSuccessor() <em>Successor</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSuccessor()
	 * @generated
	 * @ordered
	 */
	protected EList successor = null;

	/**
	 * The cached value of the '{@link #getCommunicationConnection()
	 * <em>Communication Connection</em>}' reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getCommunicationConnection()
	 * @generated
	 * @ordered
	 */
	protected AssociationRole communicationConnection = null;

	/**
	 * The cached value of the '{@link #getAction() <em>Action</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAction()
	 * @generated
	 * @ordered
	 */
	protected Action action = null;

	/**
	 * The cached value of the '{@link #getConformingStimulus()
	 * <em>Conforming Stimulus</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getConformingStimulus()
	 * @generated
	 * @ordered
	 */
	protected EList conformingStimulus = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected MessageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getMessage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Interaction getInteraction() {
		if (eContainerFeatureID != CollaborationsPackage.MESSAGE__INTERACTION)
			return null;
		return (Interaction) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInteraction(Interaction newInteraction) {
		if (newInteraction != eContainer || (eContainerFeatureID != CollaborationsPackage.MESSAGE__INTERACTION && newInteraction != null)) {
			if (EcoreUtil.isAncestor(this, newInteraction))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInteraction != null)
				msgs = ((InternalEObject) newInteraction).eInverseAdd(this, CollaborationsPackage.INTERACTION__MESSAGE, Interaction.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newInteraction, CollaborationsPackage.MESSAGE__INTERACTION, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__INTERACTION, newInteraction, newInteraction));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage() {
		if (message == null) {
			message = new EObjectWithInverseResolvingEList(Message.class, this, CollaborationsPackage.MESSAGE__MESSAGE, CollaborationsPackage.MESSAGE__ACTIVATOR);
		}
		return message;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Message getActivator() {
		if (activator != null && activator.eIsProxy()) {
			Message oldActivator = activator;
			activator = (Message) eResolveProxy((InternalEObject) activator);
			if (activator != oldActivator) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.MESSAGE__ACTIVATOR, oldActivator, activator));
			}
		}
		return activator;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Message basicGetActivator() {
		return activator;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetActivator(Message newActivator, NotificationChain msgs) {
		Message oldActivator = activator;
		activator = newActivator;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__ACTIVATOR, oldActivator, newActivator);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setActivator(Message newActivator) {
		if (newActivator != activator) {
			NotificationChain msgs = null;
			if (activator != null)
				msgs = ((InternalEObject) activator).eInverseRemove(this, CollaborationsPackage.MESSAGE__MESSAGE, Message.class, msgs);
			if (newActivator != null)
				msgs = ((InternalEObject) newActivator).eInverseAdd(this, CollaborationsPackage.MESSAGE__MESSAGE, Message.class, msgs);
			msgs = basicSetActivator(newActivator, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__ACTIVATOR, newActivator, newActivator));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClassifierRole getSender() {
		if (sender != null && sender.eIsProxy()) {
			ClassifierRole oldSender = sender;
			sender = (ClassifierRole) eResolveProxy((InternalEObject) sender);
			if (sender != oldSender) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.MESSAGE__SENDER, oldSender, sender));
			}
		}
		return sender;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ClassifierRole basicGetSender() {
		return sender;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetSender(ClassifierRole newSender, NotificationChain msgs) {
		ClassifierRole oldSender = sender;
		sender = newSender;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__SENDER, oldSender, newSender);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setSender(ClassifierRole newSender) {
		if (newSender != sender) {
			NotificationChain msgs = null;
			if (sender != null)
				msgs = ((InternalEObject) sender).eInverseRemove(this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE, ClassifierRole.class, msgs);
			if (newSender != null)
				msgs = ((InternalEObject) newSender).eInverseAdd(this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE, ClassifierRole.class, msgs);
			msgs = basicSetSender(newSender, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__SENDER, newSender, newSender));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPredecessor() {
		if (predecessor == null) {
			predecessor = new EObjectWithInverseResolvingEList.ManyInverse(Message.class, this, CollaborationsPackage.MESSAGE__PREDECESSOR, CollaborationsPackage.MESSAGE__SUCCESSOR);
		}
		return predecessor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSuccessor() {
		if (successor == null) {
			successor = new EObjectWithInverseResolvingEList.ManyInverse(Message.class, this, CollaborationsPackage.MESSAGE__SUCCESSOR, CollaborationsPackage.MESSAGE__PREDECESSOR);
		}
		return successor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationRole getCommunicationConnection() {
		if (communicationConnection != null && communicationConnection.eIsProxy()) {
			AssociationRole oldCommunicationConnection = communicationConnection;
			communicationConnection = (AssociationRole) eResolveProxy((InternalEObject) communicationConnection);
			if (communicationConnection != oldCommunicationConnection) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION, oldCommunicationConnection, communicationConnection));
			}
		}
		return communicationConnection;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationRole basicGetCommunicationConnection() {
		return communicationConnection;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetCommunicationConnection(AssociationRole newCommunicationConnection, NotificationChain msgs) {
		AssociationRole oldCommunicationConnection = communicationConnection;
		communicationConnection = newCommunicationConnection;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION, oldCommunicationConnection,
					newCommunicationConnection);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setCommunicationConnection(AssociationRole newCommunicationConnection) {
		if (newCommunicationConnection != communicationConnection) {
			NotificationChain msgs = null;
			if (communicationConnection != null)
				msgs = ((InternalEObject) communicationConnection).eInverseRemove(this, CollaborationsPackage.ASSOCIATION_ROLE__MESSAGE, AssociationRole.class, msgs);
			if (newCommunicationConnection != null)
				msgs = ((InternalEObject) newCommunicationConnection).eInverseAdd(this, CollaborationsPackage.ASSOCIATION_ROLE__MESSAGE, AssociationRole.class, msgs);
			msgs = basicSetCommunicationConnection(newCommunicationConnection, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION, newCommunicationConnection, newCommunicationConnection));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getAction() {
		if (action != null && action.eIsProxy()) {
			Action oldAction = action;
			action = (Action) eResolveProxy((InternalEObject) action);
			if (action != oldAction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CollaborationsPackage.MESSAGE__ACTION, oldAction, action));
			}
		}
		return action;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action basicGetAction() {
		return action;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAction(Action newAction, NotificationChain msgs) {
		Action oldAction = action;
		action = newAction;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__ACTION, oldAction, newAction);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAction(Action newAction) {
		if (newAction != action) {
			NotificationChain msgs = null;
			if (action != null)
				msgs = ((InternalEObject) action).eInverseRemove(this, Common_behaviorPackage.ACTION__MESSAGE, Action.class, msgs);
			if (newAction != null)
				msgs = ((InternalEObject) newAction).eInverseAdd(this, Common_behaviorPackage.ACTION__MESSAGE, Action.class, msgs);
			msgs = basicSetAction(newAction, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.MESSAGE__ACTION, newAction, newAction));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getConformingStimulus() {
		if (conformingStimulus == null) {
			conformingStimulus = new EObjectWithInverseResolvingEList.ManyInverse(Stimulus.class, this, CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS,
					Common_behaviorPackage.STIMULUS__PLAYED_ROLE);
		}
		return conformingStimulus;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.MESSAGE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.MESSAGE__NAMESPACE, msgs);
			case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.MESSAGE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__INTERACTION:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.MESSAGE__INTERACTION, msgs);
			case CollaborationsPackage.MESSAGE__MESSAGE:
				return ((InternalEList) getMessage()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ACTIVATOR:
				if (activator != null)
					msgs = ((InternalEObject) activator).eInverseRemove(this, CollaborationsPackage.MESSAGE__MESSAGE, Message.class, msgs);
				return basicSetActivator((Message) otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SENDER:
				if (sender != null)
					msgs = ((InternalEObject) sender).eInverseRemove(this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE, ClassifierRole.class, msgs);
				return basicSetSender((ClassifierRole) otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PREDECESSOR:
				return ((InternalEList) getPredecessor()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SUCCESSOR:
				return ((InternalEList) getSuccessor()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
				if (communicationConnection != null)
					msgs = ((InternalEObject) communicationConnection).eInverseRemove(this, CollaborationsPackage.ASSOCIATION_ROLE__MESSAGE, AssociationRole.class, msgs);
				return basicSetCommunicationConnection((AssociationRole) otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ACTION:
				if (action != null)
					msgs = ((InternalEObject) action).eInverseRemove(this, Common_behaviorPackage.ACTION__MESSAGE, Action.class, msgs);
				return basicSetAction((Action) otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
				return ((InternalEList) getConformingStimulus()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.MESSAGE__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.MESSAGE__NAMESPACE, msgs);
			case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.MESSAGE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__INTERACTION:
				return eBasicSetContainer(null, CollaborationsPackage.MESSAGE__INTERACTION, msgs);
			case CollaborationsPackage.MESSAGE__MESSAGE:
				return ((InternalEList) getMessage()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__ACTIVATOR:
				return basicSetActivator(null, msgs);
			case CollaborationsPackage.MESSAGE__SENDER:
				return basicSetSender(null, msgs);
			case CollaborationsPackage.MESSAGE__PREDECESSOR:
				return ((InternalEList) getPredecessor()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__SUCCESSOR:
				return ((InternalEList) getSuccessor()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
				return basicSetCommunicationConnection(null, msgs);
			case CollaborationsPackage.MESSAGE__ACTION:
				return basicSetAction(null, msgs);
			case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
				return ((InternalEList) getConformingStimulus()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.MESSAGE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case CollaborationsPackage.MESSAGE__INTERACTION:
				return eContainer.eInverseRemove(this, CollaborationsPackage.INTERACTION__MESSAGE, Interaction.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.MESSAGE__NAME:
			return getName();
		case CollaborationsPackage.MESSAGE__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.MESSAGE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.MESSAGE__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.MESSAGE__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.MESSAGE__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.MESSAGE__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.MESSAGE__COMMENT:
			return getComment();
		case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.MESSAGE__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.MESSAGE__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.MESSAGE__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.MESSAGE__PARTITION:
			return getPartition();
		case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.MESSAGE__INTERACTION:
			return getInteraction();
		case CollaborationsPackage.MESSAGE__MESSAGE:
			return getMessage();
		case CollaborationsPackage.MESSAGE__ACTIVATOR:
			if (resolve)
				return getActivator();
			return basicGetActivator();
		case CollaborationsPackage.MESSAGE__SENDER:
			if (resolve)
				return getSender();
			return basicGetSender();
		case CollaborationsPackage.MESSAGE__PREDECESSOR:
			return getPredecessor();
		case CollaborationsPackage.MESSAGE__SUCCESSOR:
			return getSuccessor();
		case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
			if (resolve)
				return getCommunicationConnection();
			return basicGetCommunicationConnection();
		case CollaborationsPackage.MESSAGE__ACTION:
			if (resolve)
				return getAction();
			return basicGetAction();
		case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
			return getConformingStimulus();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.MESSAGE__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.MESSAGE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.MESSAGE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.MESSAGE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.MESSAGE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__INTERACTION:
			setInteraction((Interaction) newValue);
			return;
		case CollaborationsPackage.MESSAGE__MESSAGE:
			getMessage().clear();
			getMessage().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__ACTIVATOR:
			setActivator((Message) newValue);
			return;
		case CollaborationsPackage.MESSAGE__SENDER:
			setSender((ClassifierRole) newValue);
			return;
		case CollaborationsPackage.MESSAGE__PREDECESSOR:
			getPredecessor().clear();
			getPredecessor().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__SUCCESSOR:
			getSuccessor().clear();
			getSuccessor().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
			setCommunicationConnection((AssociationRole) newValue);
			return;
		case CollaborationsPackage.MESSAGE__ACTION:
			setAction((Action) newValue);
			return;
		case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
			getConformingStimulus().clear();
			getConformingStimulus().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.MESSAGE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.MESSAGE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.MESSAGE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.MESSAGE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.MESSAGE__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.MESSAGE__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.MESSAGE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.MESSAGE__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.MESSAGE__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.MESSAGE__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.MESSAGE__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.MESSAGE__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.MESSAGE__INTERACTION:
			setInteraction((Interaction) null);
			return;
		case CollaborationsPackage.MESSAGE__MESSAGE:
			getMessage().clear();
			return;
		case CollaborationsPackage.MESSAGE__ACTIVATOR:
			setActivator((Message) null);
			return;
		case CollaborationsPackage.MESSAGE__SENDER:
			setSender((ClassifierRole) null);
			return;
		case CollaborationsPackage.MESSAGE__PREDECESSOR:
			getPredecessor().clear();
			return;
		case CollaborationsPackage.MESSAGE__SUCCESSOR:
			getSuccessor().clear();
			return;
		case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
			setCommunicationConnection((AssociationRole) null);
			return;
		case CollaborationsPackage.MESSAGE__ACTION:
			setAction((Action) null);
			return;
		case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
			getConformingStimulus().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.MESSAGE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.MESSAGE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.MESSAGE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.MESSAGE__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.MESSAGE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.MESSAGE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.MESSAGE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.MESSAGE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.MESSAGE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.MESSAGE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.MESSAGE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.MESSAGE__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.MESSAGE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.MESSAGE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.MESSAGE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.MESSAGE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.MESSAGE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.MESSAGE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.MESSAGE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.MESSAGE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.MESSAGE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.MESSAGE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.MESSAGE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.MESSAGE__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.MESSAGE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.MESSAGE__INTERACTION:
			return getInteraction() != null;
		case CollaborationsPackage.MESSAGE__MESSAGE:
			return message != null && !message.isEmpty();
		case CollaborationsPackage.MESSAGE__ACTIVATOR:
			return activator != null;
		case CollaborationsPackage.MESSAGE__SENDER:
			return sender != null;
		case CollaborationsPackage.MESSAGE__PREDECESSOR:
			return predecessor != null && !predecessor.isEmpty();
		case CollaborationsPackage.MESSAGE__SUCCESSOR:
			return successor != null && !successor.isEmpty();
		case CollaborationsPackage.MESSAGE__COMMUNICATION_CONNECTION:
			return communicationConnection != null;
		case CollaborationsPackage.MESSAGE__ACTION:
			return action != null;
		case CollaborationsPackage.MESSAGE__CONFORMING_STIMULUS:
			return conformingStimulus != null && !conformingStimulus.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // MessageImpl
