/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.tools.ui.views;

import java.util.ArrayList;
import java.util.List;

import fr.obeo.acceleo.tools.ui.views.log.AbstractEntry;
import fr.obeo.acceleo.tools.ui.views.log.LogEntry;

/**
 * The logs view for the acceleo tools.
 * 
 * @author www.obeo.fr
 * 
 */
public class LogView extends fr.obeo.acceleo.tools.ui.views.log.LogView {

	public AbstractEntry[] getElements() {
		List result = new ArrayList();
		AbstractEntry[] entries = super.getElements();
		for (int i = 0; i < entries.length; i++) {
			AbstractEntry entry = entries[i];
			if ((entry instanceof LogEntry) && (((LogEntry) entry).getPluginId().startsWith("fr.obeo"))) { //$NON-NLS-1$
				result.add(entry);
			}
		}
		return (LogEntry[]) result.toArray(new LogEntry[result.size()]);
	}

}
